'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function (matchersFactories) {
    return function (Component) {
        var DataSender = (function (_React$Component) {
            (0, _inherits3.default)(DataSender, _React$Component);

            function DataSender(props, context) {
                (0, _classCallCheck3.default)(this, DataSender);

                var _this = (0, _possibleConstructorReturn3.default)(this, Object.getPrototypeOf(DataSender).call(this, props, context));

                _this.dataState = context.state;

                if (typeof _this.dataState === 'undefined') {
                    (0, _throwError2.default)('missing state. It can happen if you forgot to set state in DataInit\n                        or using any decorator before DataInit', _this.constructor.displayName);
                }
                return _this;
            }

            (0, _createClass3.default)(DataSender, [{
                key: 'componentDidMount',
                value: function componentDidMount() {
                    this.dataState._registerSender(matchersFactories);
                }
            }, {
                key: 'componentWillUnmount',
                value: function componentWillUnmount() {
                    this.dataState._unregisterSender(matchersFactories);
                }
            }, {
                key: 'render',
                value: function render() {
                    return _react2.default.createElement(Component, this.props, this.props.children);
                }
            }]);
            return DataSender;
        })(_react2.default.Component);

        DataSender.contextTypes = {
            state: _react2.default.PropTypes.instanceOf(_state2.default)
        };

        return DataSender;
    };
};

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _state = require('./state');

var _state2 = _interopRequireDefault(_state);

var _throwError = require('./throw-error');

var _throwError2 = _interopRequireDefault(_throwError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }